Subject: [nemo] issue 2 diffs

From: "Pascal Thubert \(pthubert\)" <[email-masked]>
Date: Mon, 10 Jan 2005 16:09:26 +0100

Hi:

Here are the proposed diff for issue 2. 

I created a new section prior to extended with MIP reminders to help
explain the difference later. Then I added a new section in extended and
aggregated to place the deployment caveats as suggested by David. I
followed Alex recommendation and presented that the most natural way in
extended in a Home Address from the Home Link Prefix and in aggregated,
from the MNP. 

Maybe it's easier for you to check the WIP for 02 at:
http://mobilenetworks.org/~pthubert/draft-ietf-nemo-home-network-models-
xx.html

Please let me know your comments on the proposed changes :)

Issue 2 diffs:
--------------

--- draft-ietf-nemo-home-network-models-xx.xml0	2005-01-10
10:09:39.554767700 +0100
+++ draft-ietf-nemo-home-network-models-xx.xml	2005-01-10
15:56:55.912533300 +0100
@@ -68,17 +68,23 @@
     Home Network. How the two concepts relate in a given deployment
depend on the
     organization of the Home Network, as described below.</t>
 
-    <t>Four different organizations of the Home Network including
+
+
+    <t>Five different organizations of the Home Network including
        a hierarchical construction are documented:
 	<list style="hanging">
-	<t hangText="Extended Home Network:">
+	<t hangText="MIPv6 Home Network:">
+	A short reminder of what the Home Network is with Mobile IP, in
order
+	to help the reader figure out the evolution towards NEMO.
+        </t>
+	<t hangText="NEMO Extended Home Network:">
 	In this disposition, the Home Network is only one subnet of a
larger
 	aggregation that encompasses the Mobile Networks, called
extended
 	Home Network. When at Home, a Mobile Router performs normal
 	routing between the Home Link and the Mobile Networks. More
         in <xref target="app2" />.
 	</t>
-	<t hangText="Aggregated Home Network:">
+	<t hangText="NEMO Aggregated Home Network:">
 	In this disposition, the Home Network actually overlaps
 	with the Mobile Networks. When at Home, a Mobile Router acts as 
 	a bridge between the Home Link and the Mobile Networks. More
@@ -89,7 +95,7 @@
 	Mobile Routers to come back Home to. More
         in <xref target="vHome" />.
 	</t>
-	<t hangText="Mobile Home Network:">
+	<t hangText="NEMO Mobile Home Network:">
 	In this disposition, there is a bitwise hierarchy of Home
 	Networks.
 	A global Home Network is advertised to the infrastructure by a 
@@ -244,15 +250,42 @@
               <vspace blankLines="100" />
 <!-- ****************************************************************
-->
 <!-- ****************************************************************
-->
-     <section anchor='app2' title="Extended Home Network">
+     <section anchor='mip' title="MIP Home Network">
+
+
+ <t>With <xref target="RFC3775">Mobile IPv6 (MIP6) specification</xref>
+Mobile Nodes are at Home when they are connected to their Home Link,
where they
+recognize their Home Prefix in Router Advertisement messages.
+Also, a binding is checked using of Duplicate Address Detection on the
Home Link,
+and Home Agents discover each other by means of Neighbor Discovery
extensions over
+that link.
+</t>
+<t>The Home Prefix, that is advertized on the Home Link, is a final
prefix, as opposed to
+an aggregation, and it may be used by hosts on the Home Link for
autoconfiguration
+purposes.
+</t>
+<t>
+As we see, the concept of a Home Network for Mobile IPv6 is really a
prefix on a link,
+served by one or more Home Agents as opposed to a routed mesh.
+We will see in the next sections that NEMO needs additional prefixes
for use
+by the Mobile Networks. For that reason, NEMO extends the concept of
+Home Network into a more complex, aggregated structure.
+</t>
+
+     </section>
+<!-- ****************************************************************
-->
+<!-- ****************************************************************
-->
+              <vspace blankLines="100" />
+<!-- ****************************************************************
-->
+<!-- ****************************************************************
-->
+     <section anchor='app2' title="NEMO Extended Home Network">
      <section anchor='app21' title="Configuration">
 
-	<t>One simple approach is to reserve one or several subnets from
an
-        aggregation
-	for the Home Link, and to use the other subnets as MNPs.
-	In that case, the Home Network and the Mobile Networks do not
overlap.
-	The aggregation is called an Extended Home Network
-	and depicted in <xref target="fig1" />.</t>
+<t>One simple way of extending the MIP Home Network is to use
additional prefixes,
+contiguous to the Home Link Prefix inherited from MIPv6, as Mobile
Network Prefixes.
+As this model trivially extends the MIP Home Network, the resulting
+aggregation is called a NEMO Extended Home Network.
+It is depicted in <xref target="fig1" />.</t>
 
 <figure anchor='fig1' title="Extended Home Network" >
 <artwork><![CDATA[
@@ -289,15 +322,12 @@
 	the Home Network and the MNPs, since it is an
 	aggregation (can be for example /48).
         </t>
-	<t>The Mobile Routers are assigned individually a Home Address
from the 
-	Home Network and use is to register their MNP(es). 
-	In that case, the Home Agent performs
-	DAD in the Home Network as prescribed by 
- 	Mobile IPv6 for the Home Addresses.
-	</t>
-	<t>Alternatively, a Mobile Router could also form a Home Address
from one
-	of its prefixes and use it to register, performing its own DAD
on its
-        ingress network.
+	<t>Since the Extended Home Network operations inherit trivially
from MIPv6,
+	it can be seen as natural that the Mobile Routers be assigned
their Home Addresses
+	from the prefix on the Home Link, as opposed to their own MNP,
which is allowed
+	by the NEMO specification.
+	In that case, a Home Agent can perform DAD on the Home Link
+	as prescribed by Mobile IPv6 for the Mobile Router Home
Addresses.
 	</t>
       </list>
 
@@ -312,54 +342,87 @@
 	<t>A Mobile Router returns Home
 	by connecting directly to the Home Link, and dropping the MRHA
tunnel.</t>
 
-	<t>If the Home Address of the Mobile Router is derived from one
of its Mobile
-	Network Prefixes, then the MR may connect to the Home Link using
an egress interface
-	and autoconfigure an address on the Home Link. The MR recognizes
the prefix
-	of its Home Agent in order to decide that it is Home. Note that
in that case
-	the Home Address does not match the Home Prefix, so there is an
need to configure
-	the range for the extended Home Network in order to validate the
Home Address</t>
-	<t>It might seem more natural to take the Home Address from the
prefix on the Home Link,
-	and operate as MIP does on that link, including DAD operations.
</t>
-
-	<t>When at home, the Mobile Router ensures the connectivity of
the 
+	<t>When at home, the Mobile Router ensures the connectivity of
the
 	Mobile Network using standard router operations.</t>
 
 	<t>In implicit mode, the HA has the necessary information to
continue routing
 	to the MNPs in the absence of registration, and
 	 the participation of the MR to the Home IGP is not
required.</t>
 
-	<t>But explicit mode, or if the MR uses an IGP over the MRHA
tunnel,
-	then it must resume its IGP operations on
-	the Home Link in order to advertise its Mobile Networks.</t>
+	<t>But in explicit mode, or if the MR uses an IGP over the MRHA
tunnel,
+	then it must resume its IGP operations on the Home Link in order
to advertise
+	its Mobile Networks.</t>
 
 	<t>Alternate procedures for ensuring the connectivity of the
Mobile
 	Networks when at home are described in <xref target="vHome" />.
 	</t>
      </section>
 
+
+<section anchor='edh' title="Deployment Caveats">
+<section anchor='edha' title="HA side">
+
+	<t>We saw that a natural extension of the MIP procedure is to
derive the Home
+	Address of a Mobile Router from the prefix on the Home Link.
Alternatively, NEMO
+	basic supports allows that a Mobile Router forms its Home
Address from one of its
+	Mobile Network Prefixes.</t>
+
+
+	<t>In that case, the MR may connect to the Home Link using an
egress interface
+	and autoconfigure an address on the Home Link. The MR recognizes
the prefix
+	of its Home Agent in order to decide that it is at Home, as
opposed to matching
+	the prefix on the Home Link with that of its Home Address.</t>
+
+	<t> Also, the MR is responsible for performing its own DAD on
its
+        ingress network, and this has a few consequences on the
behavior of the Home Agent
+	</t>
+
+	<t>So, if the Home Address does not match the Home Prefix, then
there is a need to
+	configure the support for the extended Home Network and the
range of the
+	aggregation on the HA.
+	Based on that new configuration, the HA can accept a Home
Address that is not from
+	the Home Link, and it knows that it should not perform any DAD.
But
+	if an implementation is simply derived from that of MIP, then
this capability
+	might not exist, and the HA will not be able to accept a Home
Address based on
+	the MNP.</t>
+
+</section>
+
+<section anchor='edhm' title="MR side">
+	<t>In explicit mode, a specific support on the MR is required to
control
+	the IGP operation depending on whether a MR is at Home or not.
This support
+	might not be present in all implementations.</t>
+
+</section>
+</section>
+
 <section anchor='eapp' title="Applicability">
 <t>The extended Home Network keeps the MIP6 concept of a Home Network
for both
 Mobile Nodes and Mobile Routers to take their Home Address from. Since
there is no
 overlap between the prefixes that are affected to MNPs and prefix(es)
that are
 dedicated to the Home Link, it is possible for MNs and MRs to coexist
with that
-model. 
-   
-</t>	
-</section>
+model.</t>
+
+<t> Also, when the Home Address is derived from the prefix on the Home
Link, the
+HA behavior on the link trivially extends that of MIP and the support
should for that
+configuration should be available with all implementations.
+</t>

 </section>
+</section>
 <!-- ****************************************************************
-->
 <!-- ****************************************************************
-->
               <vspace blankLines="100" />
 <!-- ****************************************************************
-->
 <!-- ****************************************************************
-->
-     <section anchor='app1' title="Aggregated Home">
+     <section anchor='app1' title="NEMO Aggregated Home Network">
      <section anchor='app12' title="Configuration">
 
         <t>One other approach is to consider that the Aggregation of
all the
-	MNPs is used plainly as the Home Network, referred to as
-	the Aggregated Home Network. This means that the Mobile
Aggregated
+	MNPs is used plainly as the Home Link Prefix. In this model, the
+	Home Network is referred to as a NEMO
+	Aggregated Home Network. This means that the Mobile Aggregated
 	Prefix is configured on the Home Link and advertised by the Home
Agent
 	as a subnet, as depicted in <xref target="fig2" />.</t>
 
@@ -383,23 +446,17 @@
 
 ]]></artwork>
 </figure>
+     <t>In that model, it seems natural to subnet the whole range of
addresses into
+        Mobile Network prefixes, as opposed to reserving one prefix for
the Home Link,
+	which would boil down to the Extended Home Network model. If the
prefix on the Home
+	Link is really an aggregation and not a final prefix, it should
not be allowed for
+	autoconfiguration or Home Address allocation.</t>
 
-	<t>A node on the Home Link computes that the Aggregated Home
Network
-	is actually a subnet on the Home Link and may use the prefix on
the Home Link to
-	autoconfigure a Home Address.
-	Such a node may also install a connected route to the Aggregated
-	Home Network over the Home Link.</t>
-	<t>As a result, unless the node has a better (longest match)
route to a given
-        MNP, it will lookup all MNNs using Neighbor Discovery
-	over the Home Link.</t>
-
- 	<t>Thus, the Home Agent MUST intercept all the packets to the
MNNs
-	on the registered prefixes. In order to do so, the Home Agent
might
-	perform ND proxying for all addresses in all registered Mobile
Network
-	Prefixes, and protect the MNP space from autoconfiguration
-	by uncontrolled visitors on the Home Link.</t>
-	<t>Alternatives based on a routing protocol or ICMP redirect may
apply
-	in some cases.</t>
+	<t>Note that in that case, it makes sense
+	for a Mobile Router to register using a Home Address from
+	one of its own MNPs. Taking the Home Address from its own range
guarantees
+	the unicity of the suffix. That unicity can be checked by the MR
on its
+	ingress network using DAD.</t>

      </section>
@@ -411,27 +468,14 @@
 	Home Network over the Home Link.</t>
 
 	<t> A Mobile Router returns Home
-	by connecting directly to the Home Link, and dropping the MRHA
-	tunnel.
+	by connecting directly to the Home Link, and dropping the MRHA
tunnel.
 	The Mobile Router recognizes its Home Link by a prefix match
with its
 	Home Agent. </t>
 
 	<t>Note that it must expect a shorter prefix than that of its
 	Mobile Networks, even if its Home Address is formed out of one
of
-	its MNPs,
-	but that the Home Address matches the Home Network Prefix.</t>
+	its MNPs, but that the Home Address still matches the Home
Network Prefix.</t>
 
-	<t>Also, Note that in that case, it makes sense
-	for a Mobile Router to register using a Home Address from
-	one of its own MNPs. Taking the Home Address from its own range
guarantees
-	the unicity of the suffix. That unicity can be checked by the MR
on its
-	ingress network using DAD.</t>
-
-	<t>Finally, note that NEMO basic support does not check for the
unicity of a
-	registered prefix the way MIPv6 checks for the unicity of a Home
Address.
-	It is thus possible for 2 different MRs to register the same
prefix with
-	different Home Addresses, and this will cause an undetected
problem if the
-	corresponding ingress links are not connected.</t>
 
     <section anchor='Homeeg' title="Returning Home by egress">
         <t>A Mobile Router coming Home via its egress interface
@@ -493,6 +537,7 @@
      </section>
 
      </section>
+
     <section anchor='aapp' title="Applicability">
 <t>With this model, there is no specific space for independent nodes
 as any address in the aggregation belongs to a MNP, and thus to a
Mobile Router.
@@ -506,9 +551,63 @@
 if returning Home is required.
 </t>
      </section>
+
+<section anchor='acv' title="Deployment Caveats">
+
+<section anchor='acvh' title="HA Side">
+	<t>A node on the Home Link discovers that the Aggregated Home
Network
+	is actually a subnet on the Home Link and may use the prefix on
the Home Link to
+	autoconfigure a Home Address.
+	Such a node may also install a connected route to the Aggregated
+	Home Network over the Home Link.</t>
+
+	<t>As a result, unless the node has a better (longest match)
route to a given
+        Mobile Network Prefix, it will lookup all MNNs on that MNP
using Neighbor Discovery
+	over the Home Link.</t>
+
+ 	<t>Thus, on the Home Link, the Home Agent MUST intercept all the
packets
+	to ALL the Mobile Network Nodes on the registered prefixes.
+	In order to do so, the Home Agent might	perform some form of ND
proxying
+	for all addresses in all registered Mobile Network
+	Prefixes. The HA must also protect the MNP space from
autoconfiguration
+	by uncontrolled visitors at DAD level.</t>
+
+	<t>Alternatives based on a routing protocol or ICMP redirect may
apply
+	in some cases.</t>
+
+	<t>In any case, if an HA implementation is simply derived from
that of MIP,
+	then the capability to perform the required proxying might not
exist,
+	and there is a need to provide a specific configuration on the
HA to specify
+	that it operates in Aggregated Mode.</t>
+
+</section>
+<section anchor='acvm' title="MR side">
+
+	<t>If the MR returns Home by egress, a specific support is
required to control
+	the bridging operation depending on whether a MR is at Home or
not. This support
+	might not be present in all implementations.</t>
+
+	<t>Also, note that NEMO authorizes multiple registrations for a
same MNP by different
+	Mobile Routers. This is a case of multihoming, and it normally
means that the MRs
+	are interconnected by the ingress network that bears the common
MNP. But there is no
+	provision in NEMO basic support to test that this condition is
met at binding time
+	and maintained overtime.</t>
+	<t>
+	It is thus possible for 2 different MRs to register a same
prefix with
+	different Home Addresses, and this will cause an undetected
problem if the
+	corresponding ingress links are not connected.</t>
+
+	<t>When the Home Address of a Mobile Router is derived from its
MNP,
+	there is thus an additional risk of an undetected
misconfiguration if
+	the Home Address is autoconfigured from the ingress link as
opposed to statically
+	assigned with the MNP itself.
+	</t>
+
+</section>
 </section>

+</section>
 
 <!-- ****************************************************************
-->
 <!-- ****************************************************************
-->
@@ -772,6 +871,19 @@
 </t>
 </list>
 </section>
+
+<section anchor='changes02' title="Changes from version 01 to 02">
+
+<list style="hanging">
+	<t hangText="Issue 1:"> Editorial
+</t>
+	<t hangText="Issue 2:"> Added a caveat part in extended and
aggregated sections.
+	Also added a MIP Home Network section prior to those.
+</t>
+	<!--t hangText="Issue 3:">
+</t-->
+</list>
+</section>
 </section>

Pascal

---

From: Alexandru Petrescu <[email-masked]>
Date: Mon, 10 Jan 2005 16:58:34 +0100

Pascal Thubert (pthubert) wrote:
>  explain the difference later.

Thanks for this action.  I've read the section.  It does reflect what we
have discussed.

It is just I still do not feel comfortable with calling it "extended
model" I explain below why.  Overall it is because we seem to have
different views on deployment.  You seem to see it as one would start
from scratch to deploy a Home Network that supports mobility (first
deploy a MIP Home Link, then extend it for MRs).  I see it as a Home
Network already exists and mobility of hosts and routers is added
simultaneously (thus the prefixes are already allocated by some
prior to mobility).

> With Mobile IPv6 (MIP6) specificationJohnson, D., Perkins, C. and J. 
> Arkko, Mobility Support in IPv6, June 2004.[7] Mobile Nodes are at 
> Home when they are connected to their Home Link, where they recognize
>  their Home Prefix in Router Advertisement messages. Also, a binding 
> is checked using of Duplicate Address Detection on the Home Link, and
>  Home Agents discover each other by means of Neighbor Discovery 
> extensions over that link.
> 
> The Home Prefix, that is advertized on the Home Link, is a final 
> prefix, as opposed to an aggregation, and it may be used by hosts on 
> the Home Link for autoconfiguration purposes.
> 
> As we see, the concept of a Home Network for Mobile IPv6 is really a 
> prefix on a link, served by one or more Home Agents as opposed to a 
> routed mesh. We will see in the next sections that NEMO needs 
> additional prefixes for use by the Mobile Networks. For that reason, 
> NEMO extends the concept of Home Network into a more complex, 
> aggregated structure.

Pascal, I do not see _NEMO_ needing additional prefixes for use
of Mobile Networks.  It's subnetting that needs additional prefixes.  If
I have a MIP home link with MNs attached to it and I want to add MRs to
this home then what I have to do first is to allocate /64 prefixes (out
of the /48 pictured) as MNPs.  Then all I have to do is to add routes in
HA towards these MNPs through the respective HoAs.

This is exactly the same operation I have to do if I have a Link
(non-MIP) and want to further "subnet it" for non-mobile purposes with 
fixed routers.

That is why I'm not comfortable calling it "extended model".  It
could as well be called "subnetted mode" or simply a "network model".

When reading the draft, I get the feeling that NEMO Home Network extends
the MIP Home Network.  To me, this is a network further subnetted, NEMO
extends nothing in this.  IMHO.

> As this model trivially extends the MIP Home Network

Exactly, this "extension" is so trivial it does not even deserve a name 
IMHO.  It's plain simple networking.

If there is agreement around getting rid of "extended" then I'm fine. 
Otherwise the current text I read better than the previous (because it 
explains what "extended" means).

Alex

---

From: Daniel Shell <[email-masked]>
Date: Mon, 10 Jan 2005 11:27:12 -0500

Alex

So you seem to be saying the NEMO extended is just subnetting  as you would 
with any network.
You seem to object to the notion that somehow NEMO is extending the ipv6 
network when
all NEMO is doing is subnetted the ipv6 network and this is not really a 
mobility issue but
a network design.

How about NEMO with subnetted prefix.

At 04:58 PM 1/10/2005 +0100, Alexandru Petrescu wrote:
>>Arkko, Mobility Support in IPv6, June 2004.[7] Mobile Nodes are at Home 
>>when they are connected to their Home Link, where they recognize
>>  their Home Prefix in Router Advertisement messages. Also, a binding is 
>> checked using of Duplicate Address Detection on the Home Link, and
>>The Home Prefix, that is advertized on the Home Link, is a final prefix, 
>>as opposed to an aggregation, and it may be used by hosts on the Home 
>>Link for autoconfiguration purposes.
>>routed mesh. We will see in the next sections that NEMO needs additional 
>>prefixes for use by the Mobile Networks. For that reason, NEMO extends 
>>the concept of Home Network into a more complex, aggregated structure.
>

Dan Shell
Government Service Unit
CISCO Systems
IP mobility/Wireless/Satellite
440 331 5663

---

From: Alexandru Petrescu <[email-masked]>
Date: Mon, 10 Jan 2005 17:34:26 +0100

Daniel Shell wrote:
> So you seem to be saying the NEMO extended is just subnetting  as you
>  would with any network.

Exactly.

> You seem to object to the notion that somehow NEMO is extending the
> ipv6 network when all NEMO is doing is subnetted the ipv6 network and
> this is not really a mobility issue but a network design.

Exactly.

> How about NEMO with subnetted prefix.

Sounds good.

Alex

---

From: Vijay Devarapalli <[email-masked]>
Date: Tue, 11 Jan 2005 15:58:20 -0800

Alex,

it is true that regular IPv6 subnetting is used to allocate
prefixes for the home link and the mobile networks. no issues.

but the MR creating a route for its subnet at the HA which
actually has a subnet of its own, is what we are calling the
NEMO "Extended Home Network Model". so I dont see whats
wrong with the term.

having said that, it really only a term. I dont care if it
is changed to something else.

Pascal, do you think it might make sense to re-draw the figure
for the Extended Home Network model as follows.

                     |
           route     v  /48                        A:B:C::/48

         --+-----+-----+--+- . -+- . -+--
           |     |     |        |     |
          HA    MR1   MR2      MRi   MRN      HA link - A:B:C:0::/64
          /64   /64   /64      /64   /64      A:B:C:i::/64  1 < i <= N

                          Extended Home Network
        <----------------------------------------------------------->

          Home Net      Mobile Net    Mobile Net   ...   Mobile Net
        <------------><------------><------------> ... <------------>

Vijay

---

From: Vijay Devarapalli <[email-masked]>
Date: Tue, 11 Jan 2005 16:08:44 -0800

Pascal,

the following is already covered in the Basic Support spec.

> In that case, the Home Address does not match the Home Link 
> Prefix, and there is a need to configure the HA in a specific 
> mode with the support for the extended Home Network and the 
> range of the Mobile Network Prefixes. 

section 6.2

     -  Mobile IPv6 specification [1] requires that the Home Address in
        the Binding Update should be configured from a prefix advertised
        on the home link.  Otherwise the Binding Update is rejected
        with status value 132 [1].  This specification relaxes this
        requirement so that the Home Agent rejects the Binding Update
        only if Home Address does not belong to the prefix that the Home
        Agent is configured to serve.

so the following limitation does not exist.

> But if an implementation is simply derived from that of MIP, 
> then this capability might not exist, and the HA will not be 
> able to accept a Home Address based on the MNP.

another issue with the text.

> Thus, on the Home Link, the Home Agent MUST intercept all the 
> packets to ALL the Mobile Network Nodes on the registered 
> prefixes. In order to do so, the Home Agent might perform some 
> form of ND proxying for all addresses in all registered Mobile 
> Network Prefixes.

this is better done through a route at the HA for the MNP.
but ofcourse, the above can also be done. you might want to
mention that the HA SHOULD NOT send gratuitous proxy NAs for
the addresses in the MNP.

Vijay

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 12 Jan 2005 04:30:33 +0100

Vijay Devarapalli wrote:
> actually has a subnet of its own,

HA has a subnet of its own?  Isn't the HA the Home Link's default route 
to the Internet?  Is the Internet a subnet of HA?  I don't get it.

> is what we are calling the NEMO "Extended Home Network Model". so I
> dont see whats wrong with the term.

Vijay, it's not the NEMO MR that creates a route for its subnet at the 
HA.  This route must exist on the HA because otherwise the MNP is not 
reachable when MR is at home.  This route at the HA can be created in 
several ways[*], not related to NEMO.  This must exist prior to NEMO 
running, otherwise MNP is not reachable when MR at home.

[*] ways to create a route at HA prior to NEMO running: static, dynamic, 
at reboot, on the rt protocol config file, inserted by ospf, by ICMP 
Redirect, etc.

> is changed to something else.

Indeed it's just a term.  I feel the same as you about it.

> for the Extended Home Network model as follows.

Vijay, let me ask here. It seems in this picture the HA no longer has
two interfaces? I'm fine with that. But where is the Home Link? Is it
the common link between MRs? If yes, for this to work you need a Gateway
that is MRs' and HA's default route and that sends ICMP Redirect to HA
for the MNPs (such that HA obtains routes towards the MNPs).

It's a bit confusing to me, why don't you picture more detail, with the 
Internet, the Gateway, the ingress/egress interfaces of MR and HA.

Alex